#include <unistd.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <time.h>
#include <errno.h>
#include <fcntl.h>


#define AGGRESSIVE_TEST 1
#define USE_RENAMEAT    1

int main(int argc, char* argv[]) {
  /*if (argc != 2) {
    fprintf(stderr, "use: %s filename\n", argv[0]);
    return -1;
  }
  int len = strlen(argv[1]);
  
  char filename[len+5];
  strncpy(filename, argv[1], len);
  strncpy(&filename[len], ".lck", 4);
  filename[len+4] = '\0';
  unlink (filename);
  unlink (argv[1]);
  // creating a .lck file
  
  FILE* out = fopen(filename, "w");
  if (out == NULL) {
    perror("fopen");
    return -1;
  }
    */
  pid_t pid = fork();
  if (pid == 0) { // child

    // the child waits a while until the .lck file disappears
    /*
#if defined(AGGRESSIVE_TEST)
    while(access(filename,R_OK)==0);
#else
    struct timespec ts={0, 30*1000000};  // 50ms
    while (access(filename, R_OK) == 0) {
      nanosleep(&ts, NULL);
    }
    //fprintf(stdout, "Lock file removed, reading file\n");
#endif  

    // now we can read the file
    
    FILE* in = fopen(argv[1], "r");
    if (in == NULL) {
      perror("fopen child");
      return -1;
    }
    char buf[128];
    while(1) {
      int r=0;
      r=fread(&buf, 1, sizeof(buf), in);
      if (r>0) {
	if (fwrite(buf, sizeof(char), r, stdout)==-1) {
	  perror("fwrite");
	  return -1;
	}
      }
      if (feof(in)) break;
    }
    fclose(in);*/
   	printf("Child \n");
	sleep(10);
	open("mnt/a",0);
	printf ("opened\n");
	  return 0;
  }

  
  // wait a while
  sleep(2);
  printf("Parent \n");
  // then writing the .lck file
  /*const char buf[] = "Hello World!!\n";
  int r= fwrite(buf, sizeof(char), strlen(buf), out);
  if (r != strlen(buf)) {
    fprintf(stderr, "Error while writing into the file\n");
    return -1;
  }
  fclose(out);

  // now atomically rename the .lck file into the original name
#if defined(USE_RENAMEAT)
  if (renameat(AT_FDCWD, filename, AT_FDCWD, argv[1]) == -1) {
    perror("renameat");
    return -1;
  }
  
#else
  if (rename(filename, argv[1])==-1) {
    perror("rename");
    return -1;
  }
#endif
  */
  if (waitpid(pid,NULL,0)<0) {
    perror("waitpid pid");
    return errno;
  }
  printf("Finish\n");

  return 0;
}
